c
c *******************************************************
      SUBROUTINE WRITMOD (IERROR)
c
c Purpose : To write model data to L.U.N. "lunmod"
c
      character string*60, str10*10
c
$include:'magrav.cmn'
c
      ierror = 0
      rewind(lunmod)
c
      string= '! MAGRAV2, ver. 2.0 model file'
      write(lunmod,'(a)') string
      string= '! ----------------------------'
      write(lunmod,'(a)') string
      string='! (Note:lines with "!" as the first character are '
      write(lunmod,'(a)') string
      string='!    ignored when read, so comments may be added'

      write(lunmod,'(a)') string
      string='!    between fields)'
      write(lunmod,'(a)') string
c
c Write "kommnt" string
c
      write(lunmod,'(a)') kommnt
c
c Write observed gravity data
c
      string= '! Observed gravity data'
      write(lunmod,'(a)') string
      string= '!   no. observed points, spacing, "x" offset'
      write(lunmod,'(a)') string
      string= '!   ----------------------------------------'
      write(lunmod,'(a)') string
c
      write(lunmod,*) nfield(1)
      if (nfield(1).eq.0) go to 10
      write(lunmod,*) space(1)
      write(lunmod,*) xoffs(1)
      string = '! observed gravity data'
      write(lunmod,'(a)') string
      write(lunmod,'(f15.5)') (obs(1,k),k=1,nfield(1))
c
c Write observed magnetic data
c
10    string = '! Observed magnetic data'
      write(lunmod,'(a)') string
      string= '!  No. observed points, spacing, "x" offset'
      write(lunmod,'(a)') string
      string= '!  ----------------------------------------'
      write(lunmod,'(a)') string
c
      write(lunmod,*) nfield(2)
      if (nfield(2).eq.0) go to 15
      write(lunmod,*) space(2)
      write(lunmod,*) xoffs(2)
      string = '! observed magnetic data'
      write(lunmod,'(a)') string
      write(lunmod,'(f15.5)') (obs(2,k),k=1,nfield(2))
c
c Write magnetic field parameters
c
      string= '! Magnetic field parameters, xton, dec, dip'
      write(lunmod,'(a)') string
      string= '! -----------------------------------------'
      write(lunmod,'(a)') string
c
      write(lunmod,*) xton
      write(lunmod,*) dec
      write(lunmod,*) dip
c
c Write display parameters
c
15    string= '! Display parameters, zmax'
      write(lunmod,'(a)') string
      string= '! ------------------------'
      write(lunmod,'(a)') string
      write(lunmod,*) zmax
c
      string= '! Display parameters, grav. offset'
      write(lunmod,'(a)') string
      string= '! --------------------------------'
      write(lunmod,'(a)') string
      write(lunmod,*) offset(1)
c
      string= '! Display parameters, mag. offset'
      write(lunmod,'(a)') string
      string= '! -------------------------------'
      write(lunmod,'(a)') string
      write(lunmod,*) offset(2)
c
c Write body data
c ---------------
20    do 100, ibod=1, maxbod
        if(npts(ibod).gt.0) then
          str10= '! Body : '
          write(lunmod,1000) str10,ibod
1000      format(a,i5)
          string= '! -------------'
          write(lunmod,'(a)') string
          string= '! body no., npts, ((x(j),z(j),j=1,npts)'
          write(lunmod,'(a)') string
          write(lunmod,*) ibod
          write(lunmod,*) npts(ibod)
          write(lunmod,'(2f15.5)')
     +          (x(ipt,ibod),z(ipt,ibod),ipt=1,npts(ibod))
c
          string= '!  half strike length, declination, dip'
          write(lunmod,'(a)') string
          write(lunmod,*) bdy(ibod)        
          write(lunmod,*) bdec(ibod)        
          write(lunmod,*) bdip(ibod)        
c
          string= '!  min., actual, max. density'
          write(lunmod,'(a)') string
          write(lunmod,*)
rmmin(ibod,1),rhomag(ibod,1),rmmax(ibod,1)        
          string= '!  min., actual, max. magnetization'
          write(lunmod,'(a)') string
          write(lunmod,*)
rmmin(ibod,2),rhomag(ibod,2),rmmax(ibod,2)        
        endif
100   continue
c
      write(lunmod,'(a)') '! End of model file' 
      endfile (lunmod)
      write(*,*) ' '
      write(*,*) ' Model file written'
c
      return
      end
c
c *******************************************************
      SUBROUTINE READMOD (IERROR)
c
c Purpose : To read model data in L.U.N. lunmod
c
      character cdum*1, cline*60, str5*5, str15*15
c
$include:'magrav.cmn'
c
      itype = 0
      ierror = 0
      rewind(lunmod)
c
      read(lunmod,'(a)',end=900,err=990) cdum
      cline = 'header 2'
      read(lunmod,'(a)',end=900,err=990) cdum
c
c Read "kommnt" string
c
      cline = 'comment'
      call skipcom(lunmod,kerr)

      if(kerr.eq.1) go to 900 
      read(lunmod,'(a)',end=900,err=990) kommnt
c
c Read observed gravity data
c
      cline = 'no. obs. gravity'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) nfield(1)
      if (nfield(1).eq.0) go to 10
      itype = 1
      if (nfield(1).gt.maxobs) then
        call error('no. of observed gravity data exceeds maximum')
        go to 999
      endif
c
      cline = 'obs. gravity spacing'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) space(1)
c
      cline = 'observed gravity offset'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) xoffs(1)
c
      cline = 'observed gravity data'
      do 5 ig=1, nfield(1)
        call skipcom(lunmod,kerr)
        if(kerr.eq.1) go to 900 
        read(lunmod,*,end=900,err=990) obs(1,ig)
5     continue
      write(*,*) ' '
      write(*,*) 'Observed gravity data read'
c
c Read observed magnetic data
c
10    cline = 'no. obs. mag.'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) nfield(2)
      if (nfield(2).eq.0) go to 20
      if(itype.eq.0) itype = 2
      if (nfield(2).gt.maxobs) then
        call error('no. of observed magnetic data exceeds maximum')
        go to 999
      endif
c
      cline = 'mag. spacing'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) space(2)
c
      cline = 'mag. offset'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) xoffs(2)
c
      cline = 'mag. data'
      do 15 im=1, nfield(2)
        call skipcom(lunmod,kerr)
        if(kerr.eq.1) go to 900 
        read(lunmod,*,end=900,err=990) obs(2,im)
15    continue
      write(*,*) ' '
      write(*,*) 'Observed magnetic data read'
c
c Read magnetic field parameters
c
      cline = 'mag. "xton"'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) xton
c
      cline = 'mag. declination'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) dec
c
      cline = 'mag. dip'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) dip
c
c Read plotting parameters
c
20    cline = 'plot param.: zmax"'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) zmax
c
      cline = 'plot param.: grav. offset"'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) offset(1)
c
      cline = 'plot param.: mag. offset"'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) offset(2)
c
c Read body data
c ---------------
      nbods = 0
      str15 = 'plot par.'
c
100   cline = 'body after '//str15
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 800 
      read(lunmod,*,end=900,err=990) ibod
c
      if (ibod.gt.maxbod) then
        call error('no. of bodies exceeds maximum allowed')
        go to 999
      endif
      write(str5,'(i5)') ibod
      write(*,*)'Body',ibod,' read'
      str15 = ' Body '//str5 
c
      cline = 'no. points'//str15
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) npts(ibod)
c
      if (npts(ibod).gt.(maxnpt+1)) then
        call error('no. of body points exceeds maximum allowed')
        go to 999
      endif
c
c Initialize all body points positions to (0,0)
c
      do 150 kount = 1, maxnpt
        x(kount,ibod) = 0.
        z(kount,ibod) = 0.
150   continue
c
      cline = 'X+Z '//str15
c
      do 200 kp=1, npts(ibod)
        call skipcom(lunmod,kerr)
        if(kerr.eq.1) go to 900 
        read(lunmod,*,end=900,err=990) x(kp,ibod),z(kp,ibod)
200   continue
c
      cline = 'half strike length '//str15
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) bdy(ibod)        
c
      cline = str15//' declination'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) bdec(ibod)        
c
      cline = str15//' dip'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) bdip(ibod)        
c
      cline = 'density param. '//str15
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990)
     +    rmmin(ibod,1),rhomag(ibod,1),rmmax(ibod,1)        
c
      cline = 'mag. param. '//str15 
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990)
     +    rmmin(ibod,2),rhomag(ibod,2),rmmax(ibod,2)        
      ianom(ibod) = 1
      nbods = nbods + 1
c
c   Check if body is closed, if not, close it
c
      if(x(1,ibod).ne.x(npts(ibod),ibod).or.
     +     z(1,ibod).ne.z(npts(ibod),ibod))then
        if(npts(ibod).eq.maxnpt) npts(ibod) = npts(ibod) - 1
        npts(ibod) = npts(ibod) + 1
        ianom(ibod) = 0
        x(npts(ibod),ibod) = x(1,ibod)
        z(npts(ibod),ibod) = z(1,ibod)
        write(*, *) 'Body :', ibod, ' closed'
      endif
c
c  Check for duplicate consecutive points,
c   if found, delete them.
c
      call remdup (ibod)
      go to 100
c 
c If a body number is undefined, Reset all body co-ords to (0,0)
c
800   do 810 ibod = 1, maxbod
        if (npts(ibod).le.0) then
          ianom(ibod) = 0
          do 820 j=1 , maxnpt + 1
            x(j,ibod) = 0.0
            z(j,ibod) = 0.0
820       continue
        endif
810   continue
c
      call rean
      kalk = 1
c
      write(*,*) ' '
      write(*,*) 'MODEL SUMMARY'
      write(*,*) '-------------'
      write(*,'(a,i5)') ' Number of gravity profile points:
',nfield(1)
      write(*,'(a,i5)') ' Number of magnetic profile points:
',nfield(2)
      write(*,'(a,i5)') ' Number of bodies: ',nbods
      write(*,*) kommnt
      go to 999
c
900   call error('Unexpected E.O.F reading models file')
      go to 999
c
990   call error('Reading models file')
      write(*,*)' failed reading:',cline
c      call hret
c      
999   kalk = 1
      itypeo = -99
      return
      end
c
