c
c MAGRAV2 (V. 2.1) SUBROUTINE BLOCK : MS3 (Halo Professional)
c Edited last : Aug. 13, 1992 (10:00) ; J. Broome
c
$nofloatcalls
c ****************************************************************
      SUBROUTINE REAN
c
c purpose : To zero arrays "calc" and "ianom"
c
$include:'magrav.cmn'
c
      do 100 i=1, maxcal
        do 110 j = 1, maxobs
          calc(i,j) = 0.
110     continue
100   continue
      do 200 i = 1, maxbod
        ianom(i) = 0
200   continue
      kalk = 1
      return
      end
c ****************************************************************
      SUBROUTINE TYPBOD (IBOD)
c
c purpose : To type body coordinates and parameters
c
c parameters : ibod = "0" to print all bodies
c                      body number
c
$include:'magrav.cmn'
c
      if(nbods.eq.0) then
        call bold( 'No bodies defined!')
        return
      endif
c
      if(ibod.eq.0) then
        ibegin = 1
        iend = maxbod
      else
        ibegin = ibod
        iend = ibod
        if(npts(ibod).eq.0) then
          call error ('Body not defined.')
          return
        endif
      endif

      do 100 i = ibegin, iend 
        if(npts(i).ne.0) then
          write(*,*) ' '
          write(*,*)' Body :',i,' ,colour =',colour(i)
          write(*, *) 'Half-strike length :', bdy(i)
          if(itype.eq.1)
     +      write(*, 270) rmmin(i,1), rhomag(i,1), rmmax(i,1)
270         format(5x,'Min.,Actual, and Max. Density :',/,3f10.3)
          if(itype.eq.2)
     +      write(*, 280) rmmin(i,2), rhomag(i,2),
     +                      rmmax(i,2)
280       format(5x,'Min.,Actual, and Max. Magnetization :',/,
     +    3f10.2)
          if(itype.eq.2)write(*,290) bdec(i),bdip(i)
290       format(5x,'Declination=',f5.1,' ,Dip=',f5.1)
          npt1 = npts(i) - 1
        write(*,*)'Point no., X,         Z'
          do 110 j = 1, npt1
            write(*,'(i5,2f10.2)') j, x(j,i), z(j,i)
110       continue
        endif
100   continue
      return
      end
c
c ***********************************************************
      SUBROUTINE TYPAR
c
c Purpose : to print out magnetization or density parameters
c           for each body.
c
$include:'magrav.cmn'
c
c  gravity
      if(itype.ne.2) then
        write(*,*)'Body   minimum    actual   maximum   colour'
        write(*,*)'       density   density   density'
        do 100 i = 1, maxbod
          if(npts(i).gt.0) then
            write(*,150)i,rmmin(i,1),rhomag(i,1),rmmax(i,1),colour(i)
150         format(i4,3f10.4,' (',a10,')')
          endif
100     continue
        return
      endif
c
c  magnetics
2000  write(*,2100)
2100  format(' Body  minimum    actual   maximum   dec.  dip.',
     +'  colour',/,'                  magnetization')
      do 200 i = 1, maxbod
        if(npts(i).gt.0) then
          write(*, 151) i, rmmin(i,2), rhomag(i,2),
     +          rmmax(i,2), bdec(i), bdip(i), colour(i)
151       format (i4,3f10.2,2f6.1,' (',a10,')')
        endif
200   continue
      return
      end
c ************************************************************
      SUBROUTINE TYPANO (JBOD)
c
c purpose : To print out anomaly values for body "ibod"
c
$include:'magrav.cmn'
c
      ibod = jbod
      if(jbod.eq.0)ibod = maxcal
      if(ibod.lt.maxcal) then
        write(*,*)'Anomaly Body :', ibod,' (',colour(ibod),')'
      endif
      if(ibod.eq.maxcal) write(*, *) 'Total Anomaly'
      nf = nfield(itype)
      do 500 i = 1, nf
        if(calc(ibod,i).le.-.00001.or.calc(ibod,i).ge..00001) then
          write(*,400) i,xpos(i,itype),calc(ibod,i)
400       format(i3,1x,f10.2,1x,f10.2)
        endif
500   continue
      return
      end

c **************************************************************
      SUBROUTINE CALCAN
c
c purpose : To calculate the gravity or magnetic anomalies
c           for any bodies that have had their parameters or
c           points changed.(ianom(ibod) set to "0")
c
$include:'magrav.cmn'
c
      write(*,*)' '
      do 100 i = 1, maxobs
        calc(maxcal,i) = 0.
100   continue

      do 200 ibod = 1, maxbod
        if(npts(ibod).gt.0) then
          if(ianom(ibod).ge.0) then
            if(itype.eq.2) call mag(ibod)
            if(itype.eq.1) call gravc(ibod)
          endif
          nf = nfield(itype)
          do 210 i = 1, nf
            calc(maxcal,i) = calc(maxcal,i) + calc(ibod,i)
210       continue
        endif
200   continue
      kalk = 0
      return
      end
c
c *****************************************************************
      SUBROUTINE CHECK (NUMBER,XXX,ZZ,IDUPBD,IDUPPT,IRET)
c
c purpose : This subroutine checks points to see if they are in 
c      approximately the same place as existing points. If so
c      the body number and body point number are returned. If
c      not "iret" is set to -1 and the routine is exited.
c
c parameters : number - The "number"th duplicate point
c                       is checked for.
c              xxx    - X coordinate of point to be checked
c              zz     - Z coordinate of point to be checked
c              idupbd - body number for "number"th duplicate 
c                       point
c              iduppt - point number body "idupbd"
c              iret   - 0 for duplicated point
c                      -1 for unique point
c

$include:'magrav.cmn'

      numdup = 0
      do  100 idupbd = 1, maxbod
        npt = npts(idupbd) - 1
        if(npt.gt.0) then
          do 90 iduppt = 1, npt
            if(abs(xxx-x(iduppt,idupbd)).gt.xdis) goto 90
            if(abs(zz-z(iduppt,idupbd)).gt.zdis) goto 90
            numdup = numdup + 1
            if(numdup.lt.number) goto 90
            iret = 0
            xxx = x(iduppt,idupbd)
            zz = z(iduppt,idupbd)
            return
90        continue
        endif
100   continue

c  unique point
      iret = -1
      idupbd = 0
      iduppt = 0
      return
      end

c *************************************************************
      SUBROUTINE INSERT (XXX,ZZ,IBOD,NPT,IRET)
c
c purpose : To insert a new point with coordinates (xxx,zz) after
c          point "npt" in body "ibod".
c
c parameters: xxx   - X coordinate of new point
c             zz    - Z coordinate of new point
c             ibod  - number of body to insert point into
c             npt   - point in body after which point is to
c                     be inserted.
c             iret  - "-1" if point inserted
c                     "0" if point not inserted
c
c
$include:'magrav.cmn'

      iret = 0
      if(ibod.lt.1) return
      if(npt.gt.npts(ibod)) return
      if(npts(ibod).gt.maxnpt) then
        call error (' Maximum number of points in body')
        return
      endif
      iend = npts(ibod)
      npt = npt + 1
      npts(ibod) = npts(ibod) + 1
      if(npt.ne.npts(ibod)) then
        l = npts(ibod)
        do 100 i = npt, iend 
          x(l,ibod) = x(l-1,ibod)
          z(l,ibod) = z(l-1,ibod)
          l = l - 1
100     continue
      endif
      ianom(ibod) = 0
      x(npt,ibod) = xxx
      z(npt,ibod) = zz
      iret = -1

c     set last point  =  first just to be sure

      x(iend+1,ibod) = x(1,ibod)
      z(iend+1,ibod) = z(1,ibod)
      kalk = 1
      call remdup (ibod)
      if(igrap.ne.0) call plbod(ibod,nclr)
      return
      end

c*************************************************************
      SUBROUTINE DELETE (IBOD,NPT,IRET)
c
c purpose : To delete point "npt" from body "ibod"
c
c parameters : ibod  - body point is to be deleted from
c              npt   - number of point to be deleted
c              iret  - "0" if point is not deleted
c                      "-1" if point is deleted
c
$include:'magrav.cmn'

      iret = 0
      if(npts(ibod).eq.0) then
        call error ('Body not defined, point not deleted')
        return
      endif
      if(npt.lt.1.or.npt.gt.npts(ibod)) then
        call error (' Point not defined')
      endif
      iend = npts(ibod) - 1
      npts(ibod) = iend 
      if(npt.lt.iend) then
        do 100 i = npt, iend 
          ii = i + 1     
          x(i,ibod) = x(ii,ibod)     
          z(i,ibod) = z(ii,ibod)
100     continue
      endif
      ianom(ibod) = 0
      x(iend,ibod ) = x(1,ibod)
      z(iend,ibod ) = z(1,ibod)
      iret = -1
      kalk = 1
      call remdup(ibod)
      if(igrap.ne.0) call plbod(ibod,nclr)
      return
      end

c *****************************************************************
      SUBROUTINE MAG(IBOD)
c
c purpose : To calculate the magnetic anomaly for body "ibod"
c
c  sources bio computer note 66-1-c april 1966
c   program mag written for pdp-11 by d.heffler,agc,bio 19
c   cdc3150 fortran program mag2new,agc,bio,197...
c
c  modified for 2.5 dimensional bodies by Franca Lindia
c  using equations published by Shuey and Pasquale(1973)
c  in the journal "Geophysics".
c
      complex zi,zi1,zi2,yi,fn1,fn2,fn,yrlc,qpx,qpz,qxsm,qzsm,czero
      complex rsum,x21zi
c
$include:'magrav.cmn'
c
      do 100 k = 1, nfield(itype)
        calc(ibod,k) = 0.
100   continue
      if(rhomag(ibod,2).eq.0.) then
        ianom(ibod) = 0
        return
      endif
      write(*,*)'Calculating magnetic anomaly for body',ibod
      cdipd = degcos(dip)
      sdipd = degsin(dip)
      sdd =   degcos(xton-dec)
      cdip =  degcos(bdip(ibod))
      sdip =  degsin(bdip(ibod))
      sd =    degcos(xton-bdec(ibod))
      cdy =   degcos(90.-(xton-bdec(ibod)))
      sdt =   degsin(xton-dec)
      cdipsd = cdip*sd
      cdpcdy = cdip*cdy
      rhobod = rhomag(ibod,2) * 2.0
      y = bdy(ibod)
      ysq = y**2
      yd = 1.0/ysq
      yi = cmplx(0.,yd)   
      npt = npts(ibod)
      czero = cmplx(0.,0.)

c  check each field point

      do 3100 k = 1, nfield(itype)
        qxsm = czero
        qzsm = czero
        rsum = czero
        x1 = x(1,ibod) - xpos(k,itype)
        z1 = z(1,ibod) + zcon(2)
        if(z1.le.0.) goto 9999
        r1 = sqrt( x1**2 + z1**2 + ysq )
        zi1 = cmplx(0.,z1)  
        do 3000 j = 2, npt
          x2 = x(j,ibod) - xpos(k,itype)
          z2 = z(j,ibod) + zcon(2)
          if(z2.le.0.) goto 9999

c  if 2 points the same check the point after

          if(x1.eq.x2.and.z1.eq.z2) goto 3000
          z21 = z2 - z1
          x21 = x2 - x1
          zi = cmplx(0.,z21)  
          x21zi = x21 + zi
          zi2 = cmplx(0.,z2)  
          r2 = sqrt( x2**2 + z2**2 + ysq )
          fn1 = x21zi/(x1+zi1) * (1.0 + r1/y)
     +      +  yi* (x1*z21 - z1*x21)
          fn2 = x21zi / (x2+zi2) * (1.0 + r2/y)
     +      +  yi*(x2*z21 - z2*x21)

c top and bottom of log >0. since "zcon" not = 0

          if(fn1.eq.czero) goto 9999
          if(fn2.eq.czero) goto 9999
          fn = fn2/fn1
          yrlc = clog(fn)
          qpx = zi/x21zi * yrlc
          qpz =  -x21/x21zi * yrlc
          qxsm = qxsm + qpx
          qzsm = qzsm + qpz
          rsum = rsum + yrlc
          x1 = x2
          z1 = z2
          zi1 = zi2
          r1 = r2
3000    continue
        qtot = real(qxsm)
        pxtot = aimag(qxsm)
        pztot = aimag(qzsm)
        rytot = aimag(rsum)
        h =  cdipsd*pxtot + sdip*qtot
        v = cdipsd*qtot - sdip*pztot
        hy = cdpcdy*rytot
        calc(ibod,k) = (v*sdipd + (h*sdd - hy*sdt)*cdipd) * rhobod
3100  continue
      ianom(ibod) = -1
      return

c    error

9999  continue
      call error (' ') 
      write(*,1111) sgr1
      write(*, *) 'Body :', ibod, ' Point :', k
      write(*, *) ' Cannot be calculated with present algorithm'
      write(*, *) ' Value out of range '
      write(*, *) ' Anomaly set to zero'
      write(*, *) ' Use "GRAV" or "MAGN" command'
     +           ,' to set a larger Z constant'
      write(*,1111) sgr0
      do 10000 k = 1, nfield(itype)
        calc(ibod,k) = 0.0
10000 continue
      ianom(ibod) = 0
      return
      end

c ****************************************************************
      SUBROUTINE GRAVC(IBOD)
c
c  purpose-to calculate the gravitational anomaly for body ibod

$include:'magrav.cmn'
c
      do 100 k = 1, nfield(itype)
        calc(ibod,k) = 0.
100   continue
      if(rhomag(ibod,1).eq.0.) then
        ianom(ibod) = 0
        return
      endif
c
      write(*,*)'Calculating gravity anomaly for body ',ibod
      npt1 = npts(ibod) - 1
      y = bdy(ibod)
      do 1000 k = 1, nfield(itype)
        sum = 0.
        dist = xpos(k,itype)
        xj = x(1,ibod) - dist
        zj = z(1,ibod) + zcon(1)
        if(zj.le.0.) goto 9999
        do 200 j = 1, npt1
          xj1 = x(j+1,ibod) - dist
          zj1 = z(j+1,ibod) + zcon(1)
          if(zj1.le.0.) goto 9999
          sum = sum + deltag(xj1,xj,zj1,zj,y)
          xj = xj1
          zj = zj1
200     continue
        calc(ibod,k) = 13.346 * sum * rhomag(ibod,1)
1000  continue
      ianom(ibod) = -1
      return
c
9999  continue
      call error ('  ')
      write(*,1111) sgr1
      write(*,*)' Body: ',ibod,',Point: ',k,',depth is -ve.'
      write(*,*)' Anomaly cannot be calculated !'
      write(*,1111) sgr0
      do 10000 k = 1, nfield(itype)
        calc(ibod,k) = 0.
10000 continue
      ianom(ibod) = 0
      return
      end
