c 
c MAGRAV2 (v. 2.1)  SUBROUTINE BLOCK : MS4 (Halo Professional)
c Edited : Sept. 21, 1992, J. Broome
c Subroutine DIGIT set for Kurta/Bit Pad One digitizer
c
$nofloatcalls
c **************************************************************
      SUBROUTINE PLOBS
c
c Purpose : To plot observed data on the screen
c
      integer*2 icolor
$include:'magrav.cmn'
c
      call inidis (1,nclr)
      call setcol (iobsc)
c
      if (idiff.eq.1) return
c
c      write(*,*)'PLOBS:ostart,oend=',ostart(itype),oend(itype)
      nobsplt = oend(itype) - ostart(itype) + 1
      nn = 0
      do 100 ipt=ostart(itype), oend(itype)
        nn = nn +1
        w(nn) = obs(itype,ipt) + offset(itype)
c      write(*,*)'PLOBS:=',ipt,xpos(ipt,itype),obs(itype,ipt)
100   continue
c
      call movabs (xpos(ostart(itype),itype),w(1))
      call polyla(xpos(ostart(itype),itype),w(1),nobsplt)
c
      rad = (xupl-xlpl) * 0.002
      do 200 ipt=ostart(itype), oend(itype)
        npt = ipt - ostart(itype) + 1
        call movabs(xpos(ipt,itype),w(npt))
        icolor = 1
        call setcol (iwht)
        call cir(rad) 
200   continue
c       
      return
      end
c
c *************************************************************
      SUBROUTINE PLBOD (IBOD,ICLR)
c
c Purpose : To plot bodies on the screen
c
c parameters : ibod - body number to be plotted
c                     "0" to plot all bodies
c             iclr  - clear window to specified colour(0-255)
c                     "-1" if window is not to be cleared
c
      integer*2 iclr
$include:'magrav.cmn'
c
      if(mode.eq.1.and.zmax.lt.0) then
        write(*,*)'Profile length = ',xlen(itype),' km.'
10      write(*,'(a\)')' Enter depth of cross-section plot(km): '
        call sound(20,200)
        read(*,*,err=10) zmax
        zupl = 0.0
        zlpl = zmax
      endif
      call inidis (2,iclr)
      ist = ibod
      iend = ibod
      if(ibod.eq.0) then
        ist = 1
        iend = maxbod
      endif
c
      rad = (xupl-xlpl)*.005
      do 100 kbod = ist , iend
      if(npts(kbod).eq.0) go to 100
        call movabs (x(1,kbod),z(1,kbod))
        call polyfa(x(1,kbod),z(1,kbod),npts(kbod),kbod)
        do 110 ipt = 1 , npts(kbod)
          call setcol(iwht)
          call movabs(x(ipt,kbod),z(ipt,kbod))
          call cir (rad)
110     continue
100   continue
c
      call grid (2,adum,adum)
c
      return
      end
c
c ************************************************************
c
      SUBROUTINE PLANOM (JBOD,ICLR)
c
c Purpose : To plot the calculated anomaly for body "ibod"
c         
c parameters : jbod - body number to be plotted("0" for all)
c              iclr - colour to clear background to(0-255)
c                     "-1" if window is not to be cleared
c
      integer*2 iclr,ibod2
$include:'magrav.cmn'
c
      if (kalk.eq.1) call calcan
      ibod = jbod
      if (jbod.eq.0) ibod = maxcal
      call inidis (1,iclr)
c
c Plot calculated anomaly
c
      dmin = 999999.
      dmax = -999999.
      if(idiff.gt.0) then
        nobsplt = oend(itype) - ostart(itype) + 1
        do 50 ipt = ostart(itype), oend(itype)
          w(ipt)=calc(ibod,ipt)-obs(itype,ipt)-offset(itype)
          dmin = amin1(dmin,w(ipt))
          dmax = amax1(dmax,w(ipt))
50      continue
      else
        nobsplt = nfield(itype)
        do 100 ipt=1 , nfield(itype)
          w(ipt) = calc(ibod,ipt)
c          write(*,*)'PLANOM:ipt,w(ipt)=',ipt,w(ipt)
100     continue
      endif
c
      if(idiff.eq.1) then
        ddif = (dmax-dmin)*0.10
        difmin(itype) = dmin - ddif
        difmax(itype) = dmax + ddif
        call inidis (1,iblk)
        call setcol (igry)
      else
        if(jbod.eq.0) then
          call setcol(iwht)
        else
          ibod2 = ibod
          call setcol(ibod2)
        endif
      endif
c
      call setlns (2)
      if(idiff.eq.1) then
        call movabs (xpos(ostart(itype),itype),w(1))
        call polyla (xpos(ostart(itype),itype),w(1),nobsplt)
      else
        call movabs (xpos(1,itype),w(1))
        call polyla (xpos(1,itype),w(1),nobsplt)
      endif
      call setlns (1)
      return
      end
c
c **********************************************************
      SUBROUTINE INIDIS (IWIN,ICLR)
c
c Purpose : To set the current viewport and world coordinates
c
c Parameters: iwin - "1" for anom./obse. window
c                    "2" for body window
c             iclr - "-1" don't clear window
c                    "0-255" set window to specified colour
c
      character ctype*21
      character cmag*18,ccal*12,cobs*10,ckm*4
      character cunit*11
      integer*2 iclr
c
$include:'magrav.cmn'
c
c Set up title bar at top of screen
c
      if (itype.ne.itypeo) then
        call setvie ( 0.0, 0.0, 1.0, .03, nclr, igry)
        call setwor ( 0.0,0.0,1.0,1.0)
        call setcol (igry)
        call clr
c
        call movtca (0.05,0.1)
        call settex (1,1,0,0)
        call settcl (iwht,igry)
        cmag = '/MAGRAV2 Ver. 2.1/'
        call btext (cmag)
c
        call settex (1, 1, 0, 0)
        call movtca (0.35, 0.1) 
        if(itype.eq.1) then
          ctype = '"2.5D GRAVITY MODEL "'
        else
          ctype = '"2.5D MAGNETIC MODEL"'
        endif
        call btext (ctype)
        call chkerr
c
        call movtca (0.72, 0.25)
        call settex (1,1,0,0)
        call settcl (iobsc,iblk)
        cobs = '/observed/'
        call btext (cobs)
c
        call movtca (0.85, 0.25)
        call settcl (iwht,iblk)
        ccal = '/calculated/'
        call btext (ccal)
        itypeo = itype
      endif
c
c Set anomaly/observed window
c
      if (iwin.eq.1) then
        call setvie ( 0.0, 0.03, 1.0, .400, nclr, iclr)
        if (iclr.ne.nclr) then
          call setcol (iclr)
          call clr
        endif
        if (idiff.gt.0) then
          plmin = difmin(itype)
          plmax = difmax(itype)
        else
          plmin = anomin(itype)
          plmax = anomax(itype)
        endif
c
        call setwor(xlpl,plmin,xupl,plmax)
        call grid (iwin,plmin,plmax)
c
        ypos = (plmax-plmin)*0.05 + plmin
        xpl = xlpl + (xupl-xlpl)*0.04
        call movtca (xpl, ypos)
        call settex (1,1,0,0)
        call settcl (iwht,iblk)
        if(itype.eq.1) then
          cunit = '/mgals  /'
        else
          cunit = '/nteslas/'
        endif
        call btext (cunit)
      endif
c
c Set body window
c
      if (iwin.eq.2) then
        call setvie ( 0.0, .400, 1.0, 1.0, nclr, iclr)
        if (iclr.ne.nclr) then
          call setcol (iclr)
          call clr
        endif
        call setwor (xlpl,zlpl,xupl,zupl)
        do 10 kbod=1, maxbod
          if(npts(kbod).ne.0) go to 20
10      continue
        call grid (iwin,plmin,plmax)
          
c
20      xdis = (xupl-xlpl)/125.0
        zdis = (zlpl-zupl)/70.0
        x1 = xlpl + xdis
        z1 = zlpl - zdis
        x2 = x1 + xdis
        z2 = z1 - zdis
        call setcol (iwht)
        call box (x1,z1,x2,z2)
c
        xpl = xlpl + (xupl-xlpl)*0.05
        zpl = zlpl - (zlpl-zupl)*0.04
        call movtca (xpl, zpl )
        call settex (1,1,0,0)
        call settcl (iblk,iwht)
        ckm = '/km/'
        call btext (ckm)
      endif
      return
      end
c
c *******************************************************
      SUBROUTINE GRID (IWIN,PLMIN,PLMAX)
c
c Purpose : To draw a grid in a window and label it
c
c Parameters : IWIN - current active window
c              PLMIN - minimum for anomaly window
c              PLMAX - maximum for anomaly window
c
      integer*2 icolor
      character clab*11, clabp2*13
c
$include:'magrav.cmn'
c
      icolor = iwht
      call setcol (icolor)
      call setlns(3)
      call settcl (icolor,iblk)
c
      if(iwin.eq.1) go to 100
c
c Body window X grid
c ------------------
      call settex (1,1,1,0)
      call interval (xlpl,xupl,pos,round)
      kk = 1
      iend = 0
20    pos = pos + round
      kk = kk + 1
c      write(*,*)'xpos, xround=',pos, round
      if(pos.gt.xupl) then
        pos = xupl
        iend = 1
      endif
      clabp2 = '/           /'
      write(clab,'(f11.2)') pos
      clabp2(2:12) = clab
      call movabs (pos, zlpl)
      call lnabs  (pos, zupl)
      if(iend.eq.1) pos = pos - ((xupl-xlpl)*0.01)
      call movtca (pos, zlpl)
      if(mod(kk,2).eq.0.or.iend.eq.1) call btext(clabp2)
      if (iend.eq.0) go to 20
c
c Body window Z grid
c ------------------
25    call settex (1,1,0,0)
      call interval (zupl,zlpl,pos,round)
      kk = 0
30    pos = pos + round
      kk = kk + 1
c      write(*,*)'ypos,yround=',pos,round
      if(pos.gt.zlpl) go to 999
      clabp2 = '/           /'
      write(clab,'(f11.2)') pos
      clabp2(2:12) = clab
      call movabs (xlpl, pos)
      call lnabs  (xupl, pos)
      call movtca (xlpl, pos)
      if(mod(kk,2).eq.0) call btext(clabp2)
      go to 30
c
c Anomaly window Y grid
c ---------------------
100   call inqwor(xlsc,adum,xusc,adum)
      call settex (1,1,0,0)
      call interval (plmin,plmax,pos,round) 
      kk = 0
40    pos = pos + round
      kk = kk + 1
c      write(*,*)'plmax,zpos,round=',plmax,pos,round
      if(pos.gt.plmax) go to 999
      clabp2 = '/           /'
      write(clab,'(f11.2)') pos
      clabp2(2:12) = clab
      call movabs (xlpl, pos)
      call lnabs  (xupl, pos)
      call movtca (xlpl, pos)
      if(mod(kk,2).eq.0) call btext(clabp2)
      go to 40
c
999   call setlns (1) 
      call settex (1,1,0,0)
      return
      end    
c
c **********************************************************
      SUBROUTINE INTERVAL(AMIN,AMAX,START,AINT)
c
c Purpose : To determine the interval for the grid overlay
c
c Parameters : amin,amax - input limits of range of window
c              start - starting position for first line
c              aint    - output interval
c
      range = abs(amax - amin)
      if(range.eq.0.0) then
        write(*,*)'INTERVAL; error: amin = amax'
        write(*,*)'amin,amax=',amin,amax
        call hret
        go to 999
      endif
      icount = 0
      irem = range
10    irem = irem/10.0
      icount = icount + 1
      if(irem.gt.10) go to 10
c
c      write(*,*)'icount=',icount
      aint = 10.0 ** icount
      nn = 0
15    nlines = range/aint 
      if(nlines.lt.5) then
        aint = aint / 2.0
        nn = nn + 1
        if(nn.gt.100) then
          call error('INTERVAL:loop to label 15') 
          go to 999
        endif
        go to 15
      endif
c
c      write(*,*)'nlines=',nlines
      start = (int(min(amin,amax)/aint)-1) * aint
c
999   return
      end
c
c ************************************************************
      SUBROUTINE CURPOS (IRL)
c
c Purpose : Plots cursor on screen and returns world 
c            coordinates of the cursor when the button is pushed
c
c parameters : irl - set to "1" for rubberband line
c
      character cu165*7, cu265*7
c
$include:'magrav.cmn'
c
      cu165 = csi // '1;65H'
      cu265 = csi // '2;65H'
      dx = (xupl-xlpl)/10000.0
      dz = (zupl-zlpl)/7000.0
      cursx = dx * 100.0
      cursz = dz * (-150.0)
      call inithc (cursz,cursx,iwht)
      call inqhcu (cx,cy,ic)
c      write(*,*)'CURPOS:cursor colour=',ic
      write(*,1111) scp, sgr1
c
10    call digit
      if(jz.gt.3000.and.jz.lt.10000) then
        xc = jx*dx + xlpl
        zc = (jz-3000)*dz + zlpl
c
c Display cursor coordinates on monochrome display
c
      write(*,1111) cu165
      write(*,1000) xc
1000  format(' X = ',f6.2,' km',\)
c
      write(*,1111) cu265
      write(*,1010) zc
1010  format(' Z = ',f6.2,' km',\)
c
        if(irl.eq.1) then
          call setcol (iwht)
          call rlnabs (xc,zc)
        else
          call movhca (xc,zc)
        endif
        if (jf.ne.4) go to 10
        call sound (10,70)
        write(*,1111) sgr0, rcp
        return
      else
        go to 10
      endif
      call delln
      end
c
c ***********************************************************
      SUBROUTINE DIGIT 
c
c Purpose:  To read the digitizer cursor position and button
c           status from the serial port.
c
$include:'magrav.cmn'
c
      call readlo (jx,jz,jf)
      if(jf.gt.127) jf = jf-128
      jz = 10000 - ifix(jz*4.8828125)
      jx = ifix(jx*4.8828125)
c      write(*,*)'after, jx,jz,jf=',jx,jz,jf
      return
      end
c  ************************************************************
      SUBROUTINE GRAP
c
c Purpose : To interpret digitizer pad commands and branch to
c           the desired action 
c
      character cu165*7, cu265*7
      integer*2 mbod(15),mpt(15),jbod(15),jpt(15)
c
$include:'magrav.cmn'
c
      if(iloc.ne.1.and.iloc.ne.2) then
        write(*,*)'Tablet not enabled, call "CONF" to enable'
        call hret
        return
      endif
c
      xlpl = xpos(1,itype)
      xupl = xpos(nfield(itype),itype)
      zlpl = zmax
      zupl = 0
      mode = 1
      call sav
c
      go to 31000
5     call sav
10    call sound(10,1000)
      call delay (100)
      write(*,'(/a/)')' Select option on digitizer pad ...'
20    call digit
      if(jf.ne.4) go to 20
      call sound (10,70)
      write(*,1111) ed
      izcom = jz/1000 + 1
      ixcom = jx/1000 + 1
      if(izcom.gt.3) go to 90000
      if(ixcom.gt.10) go to 90000
c
      go to (10000,20000,30000) izcom
c
c bottom row of commands
c
10000 go to(10100,10200,10300,10400,10500,10600,10700,10800,
     +10900,11000) ixcom
c
c Type body
c ---------
10100 write(*,1111) ed
      write(*,'(/a)')' Select point in body to type.'
      call idbody(ibod)
      if(ibod.gt.0)call typbod(ibod)
      go to 10
c
c Type parameters
c ---------------
10200 write(*,1111) ed
      call typar
      go to 10
c
c Type observed
c -------------
10300 write(*,1111) ed
      call typobs
      go to 10
c
c Type anomaly
c ------------
10400 write(*,1111) ed
      write(*,'(/a)')' Enter body whose anomaly is to be printed'
      write(*,'(a\)')'  ("0" for combined anomaly) : '
      read(*,*,err=99000) ibod
      if(ibod.ne.0) then
        if(npts(ibod).eq.0) then
          call error(' A body is not defined with this number')
          go to 10
        endif
      endif
      call typano(ibod)
      go to 10
c
c Set mode to magnetics
c ---------------------
10500 if(itype.ne.2) then
        call rean
        itype = 2
        kalk = 1
        write(*,1111) ed
        write(*,*)'You are now in MAGNETICS mode.'
        go to 31000
      else
        call bold('You are already in MAGNETICS mode.')
        go to 10
      endif
c
c Set mode to gravity
c -------------------
10600 if(itype.ne.1) then
        call rean
        itype = 1
        kalk = 1
        write(*,1111) ed
        write(*,*)'You are now in GRAVITY mode.'
        go to 31000
      else
        call bold('You are already in GRAVITY mode.')
        go to 10
      endif
c
c Diff plot on/off
c -----------------
10700 idiff = -idiff
      if(idiff.gt.0) then
        write(*,*)'Difference mode now ON.'
        call planom (0,iblk)
      else
        write(*,*)'Difference mode now OFF.'
        call planom (0,iblk)
        call plobs
      endif
      go to 10
c
c Recalculate offset and plot observed
c -------------------------------------
10800 write(*,1111) ed
      write(*,'(//a)')'    1 - Automatic least squares '
      write(*,'(/a)')'    2 - Manual offset determination'
      write(*,'(//a\)')' Select type of offset calculation : '
      call sound (20,200)
      read(*,*,err=99000) ioff
      if(ioff.lt.1.or.ioff.gt.2) then
        call error('Offset type must be 1 or 2')
        go to 10800
      endif
c
c Automatic offset calculation
c
      if (ioff.eq.1) then
        write(*,*)'Current offset = ',offset(itype)
        sum = 0
        nobsplt = oend(itype) - ostart(itype) + 1
        do 10810 ipt=ostart(itype), oend(itype)
          sum = sum + calc(maxcal,ipt) - obs(itype,ipt)
10810   continue
        offset(itype) = sum/nobsplt
        write(*,*)'New    offset  = ',offset(itype)
      else
c
c Manual offset calculation
c
        write(*,*)' '
        write(*,*)'Use the cursor to select the position along the'
        write(*,*)'  profile where the calculated and observed'
        write(*,*)'  anomalies are to be set equal.' 
        write(*,*) ' '
        write(*,*)'Current offset = ',offset (itype)
c
        dx = (xupl-xlpl) /10000.0   
        call inidis (1,nclr)
        call setcol (iwht)
c
10820   call digit
        xc = jx*dx + xlpl
        call movabs (xc, anomin(itype))
        call rlnabs (xc, anomax(itype))
        if(jf.ne.4) go to 10820
c
        call sound(10,70)
        call delln
        mb1 = maxbod+1
c
c Check that selected point falls within defined observed data area
c
        if (xc.le.xpos(ostart(itype),itype).or.xc.ge.
     +     xpos(oend(itype),itype)) then
          call error ('point outside defined obs. data area')
          call hret
          go to 10800
        endif
c
        do 10830 j = ostart(itype) , oend(itype) - 1
          if(xc.lt.xpos(j+1,itype)) then
            fact = (xc - xpos(j,itype))/ space(itype)
            ao = obs(itype,j) + ((obs(itype,j+1) - obs(itype,j)) * fact)
            ac = calc(mb1,j) + ((calc(mb1,j+1) - calc(mb1,j)) * fact)
            offset(itype) = ac - ao
            write(*,*)'   New offset = ',offset(itype)
            go to 10840
          endif
10830   continue
      endif
10840 if(idiff.lt.0) then
        call plobs
      else
        call planom (0,nclr)
      endif
      go to 10
c
c Set Zoom
c --------
10900 write(*,1111) ed
10901 if (mode.eq.2) then
        call bold ('You must be in draw mode to "SET ZOOM"')
        call bold (' Call option "DRAW"')
        call sound(15,6000)
        go to 10
      endif
      call inidis(2,nclr)
      write(*,*)'Enter L.L. zoom corner, then U.R.'
      call curpos(0)
      call delay(100)
      call delhcu
      xll = xc
      zll = zc
      dx = (xupl-xlpl)/10000.0
      dz = (zupl-zlpl)/7000.0
      dz5 = -50 * dz
      dxmin = abs(0.05*(xupl-xlpl))
      dzmin = abs(0.05*(zupl-zlpl))
      kflag = 0
10910 call digit
      if(jz.gt.3000.and.jz.lt.10000) then
        xur = jx*dx + xlpl
        zur = (jz-3000)*dz + zlpl
        if(xur.lt.xll.or.zur.gt.zll) then
          if(kflag.eq.0) then
            call error(' Select point above and to the right')
            call bold ('  of the first point.')
            kflag = 1
          endif
          go to 10910
        endif
        kflag = 0
        if(xur.gt.xupl) xur=xupl
        call setcol(iwht)
      if(zur.lt.dz5) zur = zupl
        call rbox(xll,zll,xur,zur)
        if (jf.ne.4) then
          go to 10910
        else
          call sound (10,70)
          if(abs(xur-xll).lt.dxmin.or.abs(zur-zll).lt.dzmin) 
     +    then
            call error(' Zoom area too small, retry')
            call delbox
            call delay (100)
            if(xur.eq.xupl.or.zur.eq.zupl) then
              go to 10
            else
              go to 10901
            endif
          endif
10911     skxmin = xll
          skxmax = xur
          skzmin = zur
          skzmax = zll
          call delbox
          go to 20900
        endif
      else
        go to 10910
      endif
c
c Manual scale set
c ----------------
11000 call mscale
      mode = 1
      go to 20900
c
c Middle row of commands
c
20000 goto(20100,20200,20300,20400,20500,20600,20700,20800,20900,
     +21000) ixcom
c
c Delete body
c -----------
20100 write(*,1111) ed
      write(*,*)' Select a point in the body to delete'
      call idbody (ibod)
      if(ibod.gt.0) then
        call delbod (ibod)
        call plbod (0,igry)
        call planom(0,nclr)
        go to 5
      else
        go to 10
      endif
c
c Plot selected anomaly
c ---------------------
20200 write(*,1111) ed
      write(*,*)'Select a unique point in the body whose anomaly'
      write(*,*)'  you wish to see'
      call idbody (ibod)
      if(ibod.gt.0) call planom(ibod,nclr)
      go to 10
c
c Optimize body contrast
c ----------------------
20300 write(*,1111) ed
      write(*,'(/a)')' Select a point in the body whose contrast'
      write(*,*)'  is to be optimized.'
      call idbody (ibod)
      if(ibod.le.0) go to 10
c
c Select profile segment to be fitted
c
      ierr = 0
      call segmnt (ierr)
      if(ierr.ne.0) go to 10
c
      write(*,1111) ed
      call ampbod(ibod)
      call delbox
      call planom (0,nclr)
      go to 5
c
c Delete point
c ------------
20400 write(*,1111) ed
      write(*,'(/a)')' Select the point to be deleted'
      call inidis(2,nclr)
20410 n = 1
      irl = 0
      call idpoin(mbod,mpt,n,irl)
      if(n.eq.-1) then
        call bold (' WARNING, no body points deleted.')
        go to 10
      endif
      do 20430 kbod = 1 , n
        ibod = mbod(kbod)
        npt = mpt(kbod)
        call delete (ibod,npt,iret)
        if(iret.eq.-1) then
          call plbod(ibod,nclr)
          kount = kount + 1
          write(*,*)'Point',npt,' deleted from body',ibod
          if(npts(ibod).lt.3) then
            write(*,*)'Body',ibod,' deleted(less than 3 points)'
            npts(ibod) = 0
            nbods = nbods - 1
          endif
          kst = kbod + 1
          if(kst.le.n) then
            do 20425 kk = kst, n
              if(mbod(kk).eq.ibod) mpt(kk) = mpt(kk) - 1
20425       continue
          endif
        else
          call error('Point found in body but not deleted.')
        endif
20430 continue
      go to 5
c
c Insert point
c ------------
20500 write(*,1111) ed
      write(*,*)'Select point on one side of new point,'
      write(*,*)' then select the new point position,'
      write(*,*)' then select the other adjacent point.'
c
      call inidis(2,nclr)
c
c First point
c 
      n1 = 0
      irl = 0
      call idpoin(mbod,mpt,n1,irl)
      if(n1.eq.-1) then
        call error('First point not found')
        call hret
        go to 10
      endif
c
c Second point
c
      call movabs(xc,zc)
      call sound(10,1000)
      call delay(50)
      xold = xc
      zold = zc
      call curpos (1)
      call delln
      xnew = xc
      znew = zc
      call check(1,xnew,znew,idupbd,iduppt,iret)
      call movabs(xold,zold)
      call setcol(iwht)
      call lnabs (xnew,znew)
      call movabs(xnew,znew)
c
c Third point
c
      call delay (50)
      n2 = 0
      irl = 1
      call idpoin (jbod,jpt,n2,irl)
      call delln
      if(n2.eq.-1) then
        call error('Third point not found in body')
        call hret
        go to 10
      endif
c
      nins = 0
      nadj = 0
      do 20550 j1 = 1 , n1
        ibod1 = mbod(j1)
        ipt1  = mpt (j1)
        do 20555 j2 = 1 , n2
          ibod2 = jbod(j2)
          ipt2  = jpt (j2)
          if(ibod1.eq.ibod2) then
c
            if(ipt2.lt.ipt1)then
              itemp = ipt1
              ipt1 = ipt2
              ipt2 = itemp
            endif
            idpt = ipt2-ipt1
            if(idpt.ne.1) then
              if(ipt1.eq.1.and.ipt2.eq.(npts(ibod1)-1))then
                ipt1 = ipt2
                go to 20530
              endif
              nadj = 1
              go to 20550
            endif
c
20530       call insert(xnew,znew,ibod1,ipt1,iret)
            if (iret.eq.-1) then
              call setcol(iwht)
              call plbod (ibod1,nclr)
              write(*,*)'Point inserted in body',ibod1
              nins = nins + 1
            else
              call error(' Point not inserted in body')
            endif
          endif
20555   continue
20550 continue
      call delhcu
      if(nins.eq.0.and.nadj.eq.1) then
        call error( 'Selected "adjacent" points are not adjacent')
      endif
      if(nins.eq.0) go to 10
      go to 5
c
c Print screen
c ------------
20600 call prnt
      go to 10
c
20700  go to 90000
c
c Optimize contrast and calculate and plot anomaly
c -------------------------------------------------
20800 call ampl
      call planom(0,nclr)
      go to 10
c
c Sketch mode ( draw area specified by zoom coordinated )
c-------------
20900 if(mode.ne.2) then
        if(skxmin.eq.skxmax) then
          write(*,'(/a/)')' Zoom not specified, call option "ZOOM"'
          go to 10
        endif
        mode = 2
        xlpl = skxmin
        xupl = skxmax
        zlpl = skzmax
        zupl = skzmin
        call planom (0,iblk)
        call plobs
        call plbod (0,igry)
      else
        write(*,'(/a/)')' You are already in "SKETCH" mode'
        call sound(15,6000)
      endif
        go to 10
c
c Auto scaling
c ------------
21000 call ascale
      call planom (0,iblk)
      if(idiff.lt.0) call plobs
      go to 10
c
c top row of commands
c
30000 goto(30100,30200,30300,30400,30500,30600,30700,30800,30900,
     +31000) ixcom
c
c Enter body
c ------------
30100 write(*,1111) ed
      call inidis(2,nclr)
      call setcol (iwht)
      do 30105 ibod = 1 , maxbod
        if(npts(ibod).eq.0) go to 30108
30105 continue
      call error (' The maximum number of bodies already')
      call bold  ('    exists , delete a body to continue.')
      go to 10
c
30108 write(*,*)'Enter body points, in clockwise order,'
      write(*,*)'  closing the body to finish.'
      irl = 0
      npts(ibod) = 1
      nptbod = 0
c
30110 call curpos (irl)
      numb = 1
      call delay(50)
30120 call check(numb,xc,zc,idupbd,iduppt,iret)
      if (iret.eq.0.and.nptbod.ge.1) then
        if(idupbd.eq.ibod) then
          if(iduppt.eq.1.and.nptbod.gt.1) go to 30180
          if(iduppt.eq.nptbod) then
            call bold(' WARNING, your new point is too close to')
            call bold(' the last point, retry')
            go to 30110
          endif
        endif
        numb = numb + 1
        go to 30120
      endif
      irl = 1
      if (nptbod.ge.maxnpt) then
        call bold ('Maximum number of points entered, body closed.')
        go to 30180
      endif
      nptbod = npts(ibod)
      npts(ibod) = npts(ibod) + 1
      if(nptbod.eq.1) then
        call movabs(xc,zc)
        call delhcu
      else
        call delln
        call setcol (iwht)
        call lnabs (xc,zc)
      endif
      x(nptbod,ibod) = xc
      z(nptbod,ibod) = zc
      x(npts(ibod),ibod) = x(1,ibod)
      z(npts(ibod),ibod) = z(1,ibod)
      go to 30110
c
30180 call delln
      call setcol (iwht)
      call lnabs(xc,zc)
      call plbod (ibod,nclr)
      nbods = nbods + 1
      nptsm1 = npts(ibod) - 1
      write(*,*)'Body',ibod,' created with',nptsm1,' points.'
      write(*,*)'Call option "EPAR" to define contrast for body'
      kalk = 1
      ianom(ibod) = 0
      go to 5
c
c Move body
c ---------
30200 write(*,1111) ed
      write(*,*)'Select a point in the body to be moved and '
      write(*,*)' move it to its new location.'
      call idbody(ibod)
      if(ibod.eq.-1) go to 10
      xold = xc
      zold = zc
      call movabs (xold,zold)
      call delay (30)
30220 call curpos (1)
      call delln
      call check(1,xc,zc,ibod2,npt2,iret)
      if(iret.eq.0.and.ibod2.eq.ibod.and.npt2.eq.npt) then
        call error('Your new and old positions are too close, retry')
        go to 30220
      endif
      dx = xold - xc
      dz = zold - zc
      do 30250 ipt = 1 , npts(ibod)
        x(ipt,ibod) = x(ipt,ibod) - dx
        z(ipt,ibod) = z(ipt,ibod) - dz
30250 continue
      call plbod (0,igry)
      ianom(ibod) = 0
      kalk = 1
      go to 5
c
c Change parameters
c -----------------
30300 write(*,1111) ed
      write(*,'(/a)')' Select a point in the body whose parameters'
      write(*,*)'    are to be changed'
      call idbody (ibod)
      if(ibod.gt.0) then
        call param (ibod)
        go to 5
      else
        go to 10
      endif
c
c Automatic point movement
c ------------------------
30400 write(*,1111) ed
      write(*,*)'Use cursor to select point to be moved automatically'
      call inidis(2,nclr)
      n = 0
      irl = 0
      call idpoin(mbod,mpt,n,irl)
      xmpt = xc
      zmpt = zc
      if(n.lt.0) go to 10
c
c Select profile segment to be fitted
c
      ierr = 0
      call segmnt (ierr)
      if(ierr.ne.0) go to 10
c
      write(*,*)' Processing ...'
      call amove( xmpt, zmpt, 0.0, 0.0, 2)
      call delbox
      go to 5
c
c Manual point movement
c ----------------------
30500 write(*,1111) ed
      write(*,*)'Select point to be moved, then new position.'
      call inidis(2,nclr)
c
      cu165 = csi // '1;65H'
      cu265 = csi // '2;65H'
      dx = (xupl-xlpl)/10000.0
      dz = (zupl-zlpl)/7000.0
      cursx = dx * 100.0
      cursz = dz * (-150.0)
      call inithc (cursz,cursx,iwht)
      write(*,1111) scp, sgr1
c
      iquit = 0
      n = 1
      irl = 0
      plmin = anomin(itype)
      plmax = anomax(itype)
      call idpoin(mbod,mpt,n,irl)
      if(n.gt.0) then
        xcs = xc
        zcs = zc
        call delay (50)
        istart = 1
        call setxor(1)
c 
c Calculate cursor location
c
30550   xco = xc
        zco = zc
        jfo = jf
30551   call digit
        call setvie ( 0.0, .400, 1.0, 1.0, nclr, nclr)
        call setwor (xlpl,zlpl,xupl,zupl)
        call movabs(xcs,zcs)
        if(jz.gt.3000.and.jz.lt.10000) then
          xc = jx*dx + xlpl
          zc = (jz-3000)*dz + zlpl
          if(xc.eq.xco.and.zc.eq.zco.and.jf.eq.jfo) go to 30551
c
c Display cursor coordinates on monochrome display
c
          write(*,1111) cu165
          write(*,1000) xc
1000      format(' X = ',f6.2,' km',\)
c
          write(*,1111) cu265
          write(*,1010) zc
1010      format(' Z = ',f6.2,' km',\)
          call setcol (iwht)
          call lnabs (xc,zc)
          if (jf.eq.4) iquit = 1
          write(*,1111) sgr0, rcp
        else
          write(*,*)'move cursor inside body window'
          go to 30550
        endif
c 
c Modify body point position
c
        do 30560 k = 1, n
          npt = mpt(k)
          ibod = mbod(k)
          x(npt,ibod) = xc
          z(npt,ibod) = zc
          if(npt.eq.1) then
            x(npts(ibod),ibod) = xc
            z(npts(ibod),ibod) = zc
          endif
          call remdup (ibod)
          ianom(ibod) = 0
          call calcan
30560   continue
c
c Exit "manual point move" mode and draw body in final position
c
        if (iquit.eq.1) then
          call setxor (0)
          call movabs(xcs,zcs)
          call lnabs(xc,zc)
          call planom (0,nclr)
          call plbod(ibod,nclr)
          call setlns (1)
          go to 5
        else
c
c Continuously update anomaly corresponding to the current
c    cursor position
c --------------------------------------------------------
c
c Erase old anomaly and rubberband line
c
          if (istart.ne.1) then
            call setvie ( 0.0, .400, 1.0, 1.0, nclr, nclr)
            call setwor (xlpl,zlpl,xupl,zupl)
            call movabs(xcs,zcs)
            call lnabs(xco,zco)
c
            call setvie ( 0.0, 0.03, 1.0, .400, nclr, nclr)
            call setwor(xlpl,plmin,xupl,plmax)
            call setlns(2)
            call movabs (xpos(1,itype),w(1))
            call polyla (xpos(1,itype),w(1),nfield(itype))
            call setlns(1)
          else
            call setvie ( 0.0, 0.03, 1.0, .400, nclr, nclr)
            call setwor(xlpl,plmin,xupl,plmax)
          endif
c
          do 100 ipt=1 , nfield(itype)
            w(ipt) = calc(maxcal,ipt)
100       continue
c
c Draw new anomaly
c
          call setxor (1)
          call setcol(iwht)
          call setlns (2)
          call movabs (xpos(1,itype),w(1))
          call polyla (xpos(1,itype),w(1),nfield(itype))
          call setlns (1)
          istart = 0
          go to 30550
        endif
      else
        go to 10
      endif
c
c Recover
c --------
30600 call reco
      go to 31001
c
c Return to text mode
c ------------------
30700 write(*,1111) ed
      return
c
c Calculate anomaly with existing contrast and plot
c --------------------------------------------------
30800 call planom (0,nclr)
      go to 10
c
c Draw mode (full view)
c ---------------------
30900 if(mode.ne.1) then
        mode = 1
        xlpl = xpos(1,itype)
        xupl = xpos(nfield(itype),itype)
        zlpl = zmax
        zupl = 0
        call planom (0,iblk)
        call plobs
        call plbod (0,igry)
      else
        write(*,'(/a/)')' You are in already in "DRAW" mode'
        call sound(15,6000)
      endif
      go to 10
c
c Redraw entire display
c ---------------------
31000 write(*,1111) ed
31001 call planom(0,iblk)
      write(*,*)' '
      if(idiff.lt.0) then
        call plobs
        write(*,*)' Profile window minimum :',anomin(itype)
        write(*,*)' Profile window maximum :',anomax(itype)
      else   
        write(*,*)' Profile window minimum :',difmin(itype)
        write(*,*)' Profile window maximum :',difmax(itype)
      endif
      call plbod (0,igry)
      go to 10
c
c-------------------------------------------------------------
c
90000 write(*,*)'Command not recognized , try again ;'
      go to 10
c
99000 call error (' Input ERROR !')
      go to 10
c
      end
