c
c MAGRAV2 (V. 2.1) SUBROUTINE BLOCK : MS5 (Halo Professional)
c Edited last : Sept. 24, 1992;   J. Broome
c
$nofloatcalls
c
c *************************************************************
      SUBROUTINE MENOPT
c
c purpose : To print out a list of the available text options
c
$include:'magrav.cmn'
c
      write(*,1000)
1000  format('      Current Menu of Options',/,
     +'       ----------------------',/,
     +' ANOM  ASCA  CONF  CONT  DBOD  DIFF  DPOI  DRAW  DUMP  EBOD',/,
     +' ECOM  END   EOBS  EPAR  GRAV  HELP  INSE  MAGN  MAUT  MENU',/,
     +' MBOD  MPOI  MSCA  OFFS  PRNT  READ  RECO  SAVE  SKET  TABL',/, 
     +' TANO  TBOD  TCOM  TOBS  TPAR  TSCA  WRIT  ZOOM',/)
      return
      end
c
c ****************************************************************
c
      SUBROUTINE EOBSE
c
c purpose : To allow the user to enter observed anomaly data
c           from the keyboard.
c
$include:'magrav.cmn'
c     
      write(*,1000)
1000  format(
     +'Undefined observed points are defined by "-9999.0',/,
     +'Undefined points may only occur at the start and end',/,
     +'of the defined profile.  Anomalies are calculated for',/,
     +'these points allowing the anomaly beyond the observed',/,
     +' profile to be viewed',/)
      write(*,'(a\)')' Enter X profile offset (km) : '
      read(*,*,err=900) xoffs(itype)
10    write(*,'(a\)')' Enter profile sampling interval (km) : '
      read(*,*,err=900) space(itype)
      if(space(itype).le.0) then
        call error (' Sampling interval must be greater than zero')
        go to 10
      endif
20    write(*,'(a\)')' Enter No. of values in profile : '
      read(*,*,err=900) nfield(itype)
      if(nfield(itype).gt.maxobs.or.nfield(itype).le.0) then
        call error(' Number selected greater than maximum allowed')
        go to 20
      endif
      do 30 ipt=1 , nfield(itype)
30    xpos(ipt,itype) = xoffs(itype) + (ipt-1)*space(itype)
      xlen(itype) = space(itype) * (nfield(itype)-1)
      write(*,*)'Profile X length = ',xlen(itype),' km.'
      write(*,*)'Enter reading no. and measured anomaly value'
      write(*,*)' (enter 0,0 to quit)'
100   write(*,'(a\)')' no.,value : '
      read(*,*,err=100) j,ans
      if(j.eq.0) go to 200
      if(j.le.nfield(itype)) then
        obs(itype,j) = ans
        go to 100
      endif
      call error(' Reading number greater than number selected')
      go to 100
c
200   ktype = itype
      call obslim (ktype)
c
      if(igrap.ne.0.and.idiff.lt.0) then
        call ascale
        xlpl = xpos(1,itype)
        xupl = xpos(nfield(itype),itype)
        call inidis (1,0)
        call plobs
        if(nbods.gt.0) call plbod(0,127)
      endif
      return
c
900   call error( ' Input error.')
      return
      end
c
c **************************************************************
c
      SUBROUTINE ROBSE(IERR)
c
c purpose : To read observed anomaly data from a profile file.
c
c parameters : ierr - set to "1" for errors reading from file
c
c file format : record 1 - nfield(itype)
c               record 2 - space(itype)
c               record 3 to nfield+2 -obs(itype,ipt)
c                 (All data free formatted)
c
      character*50 pfile
$include:'magrav.cmn'
c
      write(*,'(/a\)')' Enter profile file filespec : '
      call sound(20,200)
      read(*,'(a)') pfile
      open(10,file=pfile,status='old',form='formatted')
      write(*,*)'file opened'
c
      read(10,*,err=999) nfield(itype)
      write(*,*)'No. of points = ',nfield(itype)
      read(10,*,err=999) space(itype)
      write(*,*)' Profile spacing read = ',space(itype)
      do 100 ipt = 1 , nfield(itype)
        read(10,*,err=999) obs(itype,ipt)
        write(*,*)' profile value ',ipt,' read'
100   continue
      write(*,1000) nfield(itype),space(itype)
1000  format(1h ,'No. of profile values read in : ',i4,/
     +' Profile value sampling interval (km): ',f10.5)
150   write(*,'(a\)')' Enter X profile offset (km) : '
      call sound(20,200)
      read(*,*,err=900) xoffs(itype)
c
      do 200 ipt=1, nfield(itype)
200   xpos(ipt,itype) = xoffs(itype) + (ipt-1)*space(itype)
      xlen(itype) = space(itype)*(nfield(itype)-1)
      write(*,*)'Profile X length = ',xlen(itype),' km.'
c
      ktype = itype
      call obslim (ktype)
c
      if(igrap.ne.0.and.idiff.lt.0) then
        call ascale
        xlpl = xpos(1,itype)
        xupl = xpos(nfield(itype),itype)
        call inidis (1,0)
        call plobs
      endif
      ierr = 0
      return
c
900   call error(' Input error!, retry.')
      go to 150
c
999   call error (' Reading profile file')
      ierr = 1
      return
      end
c
c *******************************************************
      SUBROUTINE DELBOD (IBOD)
c
c Purpose : To reinitialize parameters for deleted bodies
c
$include:'magrav.cmn'
c
      do 10  ipt=1 , maxnpt + 1
        x(ipt,ibod) = 0.0
        z(ipt,ibod) = 0.0
10    continue
      do 20 ktype=1 , ntypes
        rmmin(ibod,ktype) = 0.0
        rmmax(ibod,ktype) = 0.0
        rhomag(ibod,ktype) = 0.0
20    continue
      do 30 ipt = 1 , nfield(itype)
        calc(ibod,ipt) = 0.0
30    continue
      npts(ibod) = 0
      ianom(ibod) = 0
      kalk = 1
      nbods = nbods - 1
      if(nbods.lt.0) nbods = 0
      write(*,*)' Body ',ibod,' deleted.'
      return
      end
c
******************************************************************
      SUBROUTINE REMDUP (IBOD)
c
c Purpose : To remove duplicate consecutive points from bodies
c
$include:'magrav.cmn'
c
1     npt1 = npts(ibod) - 1
      do 10 kount = 1, npt1
        if(x(kount,ibod).eq.x(kount+1,ibod)) then
          if(z(kount,ibod).eq.z(kount+1,ibod)) then
            if(igrap.ne.0) then
               igrapo = igrap
               igrap = -99
            endif
            call delete(ibod,kount,iret)
            if(igrap.eq.-99) igrap = igrapo
            if(iret.eq.0) then
              call error(' Error deleting duplicate point, (remdup)')
              write(*,1111) sgr1
              write(*,*)'    Check body ',ibod
              write(*,1111) sgr0
            else 
              write(*, *) 'Body : ', ibod, ' Point : ', kount,
     +                           ' duplicate and deleted'
              goto 1
            endif
          endif
        endif
10    continue
c

      if(npts(ibod).le.2) then
        npts(ibod) = 0
        write(*,*)'Body ',ibod,' deleted,(less than 3 points)'
      endif
c
      return
      end
c
c ***********************************************************
      SUBROUTINE SAVEH
c
c Purpose : To save halo format picture and palette files of the 
c           colour screen display in Halo "cut" format
c
c
      character picspec*80,picname*80,cpic5*5,palnote*20,ans*80
      character cpic4*4
c
      character*1 ccutl(1500)
c
      integer*2 ifun, ierr, ixr, luncut, idlen, iy1
      integer*2 ix1, iline, iwidth, iheight, idum2
      integer*2 itseg, itlen, ifseg, iflen, length
      integer*2 nclr, inorml(1000)
c
      logical*2 fex
c
      nclr = -1
c
c Save current world and viewport coordinates and turn off
c
      call inqwor (x1w,y1w,x2w,y2w)
      call worldo
      call inqvie (x1v,y1v,x2v,y2v)
      call setvie (0.0,0.0,1.0,1.0,nclr,nclr)
c
10    write(*,'(1x,a,\)') char(27)//'[2J' 

      write(*,1000)
1000  format(/,' Enter file name for saved "Halo" image,'
     +,/,' ("esc" to quit)(".cut" will be added) : ')
      read(*,'(a)') picname
      if(picname.eq.'esc'.or.picname.eq.'ESC') return
c
      picspec(1:)  = picname
      call lcvar(l,picspec)
      cpic4 = '.cut'
      picspec(l:l+4) = cpic4
      inquire(file=picspec,exist=fex)
      if (fex.eqv..true.) then
        write(*,*)' '
        write(*,*)'A file with this name already exists'
        write(*,'(a\)')' Do you wish to overwrite the file? (y/n): '
        call sound(20,200)
        read(*,'(a)') ans
        if(ans.ne.'y'.and.ans.ne.'Y') go to 10
      endif
c
      luncut = 13
      open (luncut,file=picspec,form='binary',err=900)
c
c Determine display parameters
c
      call inqdra (ixr,iyr)
      iwidth = ixr + 1
      iheight = iyr +1
      call chkerr
      write(*,*)' '
      write(*,*) 'Image :width,height=',ixr,iyr
      write(*,*) ' '
      write(*,*) 'Processing line :'
      write(*,*) ' '
      call inqpfl (idlen,iwidth)
      call chkerr
c
c Set up and write cut file header
c
      idum2 = 0
      write(luncut) iwidth, iheight, idum2
c 
c For each line of current image
c ------------------------------
      do 100 iline = 0, iyr
        write(*,1010) iline
1010    Format (1h+,i5)
c
c Extract, compress, and write each line of screen data 
c
        ix1 = 0
        iy1 = iline
c        write(*,*)'ix1,ixr,line=',ix1,ixr,iy1
        call normfr (ix1, ixr, iy1, inorml(1))
        call chkerr
c
        itseg = 0
        itlen = 2 * iwidth
        ifseg = 0
        iflen = iwidth
        call memcom ( itseg, ccutl, itlen, ifseg, cnorml, iflen)
        call chkerr
c
        length = 2 * iwidth - itlen
        write(luncut) length, (ccutl(k), k=1,length)
c        if(iline.eq.100.or.iline.eq.400) then
c          do 800 kk=1,length
c            write(*,*) kk, ichar(ccutl(kk))
c 800       continue
c        endif
100     continue
c
      write(*,*) ' '
      write(*,*)'Halo image file created: ',picspec
c
c Write generic Halo palette file
c
      picspec(1:2) = '/'
      picspec(2:)  = picname
      call lcvar(l,picspec)
      cpic5 = '.pal/'
      picspec(l:l+5) = cpic5
      call pwrite(picspec,palnote,0)
      call inqerr (ifun,ierr)
      if (ierr.eq.0) then
        write(*,*)'Generic Halo palette file created'
      else
        call error('Error writing palette file')
      endif
      go to 999

900   call error ('opening cut file')
      call hret
c
c Restore viewport and world coordinates
c
999   call setvie (x1v,y1v,x2v,y2v,nclr,nclr)
      call setwor (x1w,y1w,x2w,y2w)
      return
      end
c
c **********************************************************
      SUBROUTINE GRINIT
c
c purpose : To initialize the "Halo" graphics functions
c           of the program; read and display a "Halo"
c           format image file on the screen and read
c           the drawing colours
c
c  igrap = 1 for IBM-compatible VGA
c  igrap = 2 for NEC Multisync Graphics Engine (1024x768-I)
c
      character*40 kernel, devdrv
      integer*2 idevh, ifun, ierr
c
$include:'magrav.cmn'
c
      if(igrap.eq.0) go to 999
c
c "Kernel" is a path statement pointing to the Halo
c   Professional Kernel  
c
      if(kernel.ne.'/c:\hpro\kernels\ahdmsfl.krn/') then
        kernel = '/c:\hpro\kernels\ahdmsfl.krn/'
        call setker (kernel)
        call inqerr(ifun,ierr)
        if(ierr.eq.0) then
          write(*,*) ' '
          write(*,*) ' Halo kernel installed'
        else
          call error('Installing Halo kernel')
          call hret
          kernel = ' '
          igrap = 0
        endif
c
c If a graphics device has been loaded, unload it.
c
      else
        call clsdev (idevh)
        call chkerr
        write(*,*)'Previously-opened Halo device closed'
      endif
c
c "devdrv" is a path statement pointing to the selected Halo
c Professional device driver
c
c VGA graphics
c 
      if(igrap.eq.1) then
        devdrv = '/c:\hpro\dev\drivers\AHDIBMV.DSP/'
        call setdev(devdrv)
        call chkerr
        call inqade (idevh)
        call chkerr
        call initgr (3)
c
c NEC-MGE running TIGA 2.05; 1024x1024x8
c
      elseif(igrap.eq.2) then
        devdrv = '/c:\hpro\dev\drivers\AHDTIGA.DSP/'
        call setdev(devdrv)
        call chkerr
        call inqade (idevh)
        call chkerr
        call initgr (0)
      endif
c
      call inqerr(ifun,ierr)
      if(ierr.ne.0) then
        call error(' Error initializing graphics,')
        igrap = 0
        go to 999
      endif
c
      call mono
      call inqerr(ifun,ierr)
      if(ierr.ne.0) then
        call error(' Error setting "mono" monitor')
        igrap = 0
        go to 999
      endif
c
      call setiee (1)
      write(*,*) ' '
      write(*,*)'Graphics  system  initialized'
c
c Read image and body colours numbers into colours arrays for
c        later use
c
      call readcol (ierr)
      call initcol
c
c "logo.pic" is a "Halo" image file displayed at the start
c  of the session.
c
c      fil = '"logo.pic"'
c      call gread (fil)
c
c Set dot text default attributes
c
      call settex ( 1, 1, 0, 0 )
c
999   return
      end
c
c ******************************************************************
      SUBROUTINE CONFIG (IMENU)
c
c Purpose: To determine if graphics or a locator are to be used and
c         set the delay factor. Defaults are stored in file 
c           "magrav2.cnf"
c
c parameters : imenu : set to "0" to read magrav2.cnf only
c                      set to "1" to display config menu
c
      character*72 cnfmen(6), cnftitl, locmen(3), loctitl
      character*72 pnttitl, pntmen(4)
      character*72 gratitl, gramen(3), filnam
      character*10 cdelay, csav
      logical fex
c
$include:'magrav.cmn'
c
      filnam = 'magrav2.cnf'
      inquire(file=filnam,exist=fex)
      if(fex.eqv..false.) then
        write(*,*)'  '
        write(*,*)' The program default file "magrav2.cnf" is'
        write(*,*)' not in the default directory.'
        write(*,*)' You will be required to set the defaults'
        call hret
        open(luncnf,file=filnam,status='new')
      else
        close (luncnf)
        open(luncnf,file=filnam,status='old',iostat=ierr)
        if (ierr.ne.0) then
          call error('opening "magrav2.cnf"')
          call bold('You will be required to set the defaults')
          open(luncnf,file=filnam,status='new')
          imenu = 1
          go to 10
        endif
        rewind luncnf
c
        ierror = 0
        read(luncnf,*, iostat=ierror) igrap, iloc, iprnt, nsav, idelay
        if(ierror.ne.0.or.idelay.lt.1) then
          call error('reading configuration file,')
          write(*,*)' You will be required to set the defaults'
          call hret
          go to 10
        else
          if(imenu.eq.1) go to 10
          go to 999
        endif
      endif
c
c Initialize flags to 0
c
      iloc = 0
      igrap = 0
      iprnt = 0
c
10    cnftitl   = ' CONFIGURATION MENU'
c
      if(igrap.eq.0)then
        cnfmen(1) = 'Graphics on/off (currently "OFF")'
      elseif(igrap.eq.1) then
        cnfmen(1) = 'Graphics on/off (currently "VGA")'
      elseif(igrap.eq.2) then
        cnfmen(1) = 'Graphics on/off (currently "NEC MGE")'
      endif
c
      if(iloc.eq.0) then
        cnfmen(2) = 'Locator status (currently:"NONE")'
      elseif(iloc.eq.1) then
        cnfmen(2) = 'Locator status (currently "HALO TABLET;COM1")'
      elseif(iloc.eq.2) then
        cnfmen(2) = 'Locator status (currently "HALO TABLET;COM2")'
      endif
c
      if(iprnt.eq.0) then
        cnfmen(3) = 'Printer status (currently : "NONE")'
      elseif(iprnt.eq.1) then
        cnfmen(3) = 'Printer status (currently : "HP Laserjet II")'
      elseif(iprnt.eq.2) then
        cnfmen(3) = 'Printer status (currently : "Tektronix 4696")'
      elseif(iprnt.eq.3) then
        cnfmen(3) = 'Printer status (currently : "Postscript")'
      endif
c
      write(cdelay,'(i10)') idelay
      cnfmen(4) = 'Locator delay factor set to '//cdelay
c
      write(csav,'(i10)') nsav
      cnfmen(5) = 'Number of recoverable steps:  '//csav
c
      cnfmen(6) = 'Continue'
c
      ierr      =  0
      nopt      =  6
c
      call menu(nopt,cnftitl,cnfmen,icnf,ierr)
c      write(*,*)'icnf,ierr=',icnf,ierr
      if(ierr.ne.0) then
        call error('CONFIG: error in configuration menu call')
        call hret
        go to 900
      endif
c
      if(icnf.eq.1) then
        gratitl   = 'GRAPHICS BOARD OPTIONS'
        gramen(1) = 'Graphics disabled'
        gramen(2) = 'Graphics enabled; VGA card'
        gramen(3) = 'Graphics enabled; NEC Multisync Graphics E.'
c
        ierr      =  0
        nopt      =  3
c
        call menu(nopt,gratitl,gramen,igrp,ierr)
        if(ierr.ne.0) then
          call error('CONFIG: error in graphics menu call')
          call hret
          go to 900
        endif
        igrap = igrp - 1
        
c
      elseif(icnf.eq.2) then
        loctitl   = 'LOCATOR OPTIONS'
        locmen(1) = 'No locator, text position entry'
        locmen(2) = 'Halo tablet locator on COM1'
        locmen(3) = 'Halo tablet locator on COM2'

c
        ierr      =  0
        nopt      =  3
c
        call menu(nopt,loctitl,locmen,iloc,ierr)
        if(ierr.ne.0) then
          call error('CONFIG: error in locator menu call')
          call hret
          go to 900
        endif
        iloc = iloc - 1
c
      elseif(icnf.eq.3) then
        pnttitl   = 'PRINTER OPTIONS'
        pntmen(1) = 'No printer'
        pntmen(2) = 'HP Laserjet II'
        pntmen(3) = 'Tektronix 4696'
        pntmen(4) = 'Postscript'
c
        ierr      =  0
        nopt      =  4
c
        call menu(nopt,pnttitl,pntmen,iprnt,ierr)
        if(ierr.ne.0) then
          call error('CONFIG: error in printer menu call')
          call hret
          go to 900
        endif
        iprnt = iprnt - 1
c
      elseif(icnf.eq.4) then
        write(*,1111) ed
        write(*,*) ' '
        write(*,*) ' The locator delay factor controls the duration of'
        write(*,*) 'delays in the program when points are picked, etc..'
        write(*,*) 'Increasing the factor increases the delay'
        write(*,*) ' The current delay factor is ',idelay
        write(*,*) ' '
        write(*,'(a\)')' Enter a new delay factor (integer) : '
        read (*,*,err=900) idelay
        if(idelay.lt.1) then
          call error('delay factor must be greater than 1')
          call hret
          go to 10 
        endif
c
      elseif(icnf.eq.5) then
        write(*,1111) ed
        write(*,*)' The number of recoverable steps saved affects the'
        write(*,*)' size of the revovery file. For floppy disc systems'
        write(*,*)' choose a small number of saved steps to keep the'
        write(*,*)' recovery file small. Selecting "0" steps '
        write(*,*)' immediately after starting the program opens a'
        write(*,*)' file but never writes anything to the file'
        write(*,*)' Current number of recovery steps is :',nsav
110      write(*,'(/a\)')' Enter new number of recovery steps : '
        call sound (20,200)
        read(*,*) nsav
        if(nsav.lt.0) then
          call error('Number of steps must be zero or greater')
          go to 110
        endif
        if(nsav.gt.20) then
          call bold('WARNING!, values greater than 20 are not ')
          call bold(' recommended as the recovery file becomes')
          call bold(' large')
        endif
c
      elseif(icnf.eq.6) then
        rewind luncnf
        write(luncnf,1000) igrap, iloc, iprnt, nsav, idelay
1000    format(5i10)
        write(*,*)'Configuration file "magrav2.cnf" updated.'
        call hret
        go to 999
      endif
      go to 10
c
900   call error ('Input error')
      go to 10
c
999   close (luncnf)
      if(igrap.gt.0) then
        call grinit
      else
        write(*,*) ' '
        write(*,*)'Graphics disabled, call option'
        write(*,*)'"CONF" to enable.'
      endif
c
      call loinit
      call setprt
      itypeo = -99
      return
      end
c
c ***********************************************************
      SUBROUTINE LOINIT
c
c Purpose: to initialize the Bit-Pad-One locator
c
      integer*2 lattr(32), ifun, kerr
      character*40 locfil
c
$include:'magrav.cmn'
c
c Initialize locator attribute array to -1
c
      do 2, jk = 1, 32
        lattr(jk) = -1
2     continue
c
      if(iloc.eq.0) then
        write(*,*) ' '
        write(*,*)'Locator disabled, call "main menu" option'
        write(*,*)'"CONF" to enable.'
        go to 999
c
c For Halo bit-pad-one locator; COM1
c
      elseif (iloc.eq.1) then
        call setloc ('//',1)
        locfil = '/c:\hpro\dev\drivers\ahdbpoi.loc/'
        call setloc (locfil,1)
        call inqerr(ifun,kerr)
        if(kerr.eq.0) then
          write(*,*) ' '
          write(*,*)'Halo locator initialized on COM1'
        else
          call error(' Unable to initialize Halo locator on COM1')
          iloc = 0
          go to 999
        endif
c
        lattr(1) = 4
        lattr(2) = 234
        lattr(3) = 2048
        lattr(4) = 2048
c
        call setlat (lattr)
        call chkerr
c
c For Halo bit-pad-one locator; COM2
c
      elseif (iloc.eq.2) then
        call setloc ('//',2)
        locfil = '/c:\hpro\dev\drivers\ahdbpoi.loc/'
        call setloc (locfil,2)
        call inqerr(ifun,kerr)
        if(kerr.eq.0) then
          write(*,*) ' '
          write(*,*)'Halo locator initialized on COM2'
        else
          call error(' Unable to initialize Halo locator on COM2')
          iloc = 0
          go to 999
        endif
c
        lattr(1) = 4
        lattr(2) = 234
        lattr(3) = 2048
        lattr(4) = 2048
c
        call setlat (lattr)
        call chkerr
c
c For Halo keyboard locator
c
      elseif (iloc.eq.3) then
        locfil = '/c:\hpro\dev\drivers\ahdkey.loc/'
        call setloc (locfil,0)
        call inqerr(ifun,kerr)
        if(kerr.eq.0) then
          write(*,*) ' '
          write(*,*)'Halo keyboard locator initialized'
          write(*,*) ' '
          write(*,*)'If keyboard driver is installed <NUM LOCK>'
          write(*,*)'must be "off" and the <F1> key toggles the'
          write(*,*)'keyboard between cursor control and text'
          write(*,*)'If the keyboard locks, press the <F1> key'
          write(*,*)'Cursor step size can be selected with keys'
          write(*,*)'1 through 9'
        else
          call error(' Unable to initialize Halo keyboard locator')
          iloc = 0
          go to 999
        endif
      endif
999   return
      end
