c
c MAGRAV2 (V. 2.1) SUBROUTINE BLOCK : MS6 (Halo Professional)
c Edited last : Aug. 14 / 1992; J. Broome
c Halo Professional version
$nofloatcalls
c
c*************************************************************
      SUBROUTINE PARAM (IBOD)
c
c purpose : To allow body magnetization parameters and half 
c           strike extent to be entered.
c
c parameters : ibod - body number for parameter change

$include:'magrav.cmn'

      write(*,*)' ' 
      write(*,*)'Body',ibod,' , ( colour=',colour(ibod),')'
      write(*,*)' '
      write(*,*)'Current half strike extent (km) = ',bdy(ibod)
10    write(*,'(a\)')' Enter new half strike extent (km) : '
      read(*,*,err=900) bdy(ibod)
      if(bdy(ibod).le.0) then
        call error (' Half strike extent must be greater than 0')
        go to 10
      endif
      if(itype.eq.1) then
        write(*,1010) rmmin(ibod,itype),rhomag(ibod,itype),
     +rmmax(ibod,itype)
1010  format(1h ,'Minimum,body, and maximum density contrasts =',/,
     + 3f10.2)
        write(*,'(a\)')' Enter minimum density contrast(g/cc): '
      else
        write(*,1020) rmmin(ibod,itype),rhomag(ibod,itype),
     +rmmax(ibod,itype)
1020  format(1h ,'Minimum,body, and maximum magnetizations =',/,
     +3f10.2)
        write(*,'(a\)')' Enter minimum magnetization (X10-5 emu): '
      endif
      call sound(20,200)
      read(*,*,err=900) rmmin(ibod,itype)
c
      if(itype.eq.1) then
        write(*,'(a\)')' Enter body density contrast(g/cc): '
      else
        write(*,'(a\)')' Enter body magnetization (X 10-5 emu) : '
      endif
      call sound(20,200)
      read(*,*,err=900) rhomag(ibod,itype)
c
      if(itype.eq.1) then
        write(*,'(a\)')' Enter maximum density contrast(g/cc): '
      else
        write(*,'(a\)')' Enter maximum magnetization (X10-5 emu): '
      endif
      call sound(20,200)
      read(*,*,err=900) rmmax(ibod,itype)
c
      if (itype.eq.2) then
      write(*,1030)dec,dip
1030  format(1h ,'Field declination = ',f8.1,/
     +,' Field dip         = ',f8.1)
        write(*,'(a\)')' Enter body magnetization declination : '
        call sound(20,200)
        read(*,*,err=900) bdec(ibod)
        write(*,'(a\)')' Enter body magnetization dip : '
        call sound(20,200)
        read(*,*,err=900) bdip(ibod)
      endif
c
      kalk = 1
      ianom(ibod) = 0
      return
c
900   call error (' Input error')
      return
      end

c *****************************************************
      SUBROUTINE TSCA
c
c purpose : To type out scaling parameters ,etc.

$include:'magrav.cmn'
c
      if(itype.eq.1) write(*, *) 'Gravity'
      if(itype.eq.2) write(*, *) 'Magnetics'
      write(*, 46) kommnt
  46  format(' Comments '/,1x,8a10)
      write(*,*)'X length of profil(km) =',xlen(itype)
      write(*,*)'Crossection depth (km) =',zmax
      write(*,*)'X profile offset (km)  =',xpos(1,itype)
      write(*,*)'Sampling interval(km)  =',space(itype)
      write(*,*)'No. of readings        =',nfield(itype)
      write(*,*)'Anomaly scale minimum  =',anomin(itype)
      write(*,*)'Anomaly scale maximum  =',anomax(itype)
      write(*,*)'Difference scale min.  =',difmin(itype)
      write(*,*)'Difference scale max.  =',difmax(itype)
      write(*,*)'Observed offset        =',offset(itype)
      write(*,*)'Number of bodies       =',nbods
      if(itype.eq.2) write(*, 210) dec, dip, xton, zcon(itype)
210   format(8x,'dec = ',f8.2,8x,' dip = ',f8.2/
     +' X to n angle : ',f8.2/8x,' Z constant : ',f8.4)
      if(mode.eq.2) write(*, *) 'Sketch mode'
      if(mode.eq.1) write(*, *) 'Draw mode'
      write(*, 227) skxmin, skxmax, skzmin, skzmax
227   format(' Sketch limits X:',2f10.2,/13x,   ' Z:',2f10.2)
      write(*,*) 'Maximum number of points per body = ', maxnpt
      write(*,*) 'Maximum number of bodies          = ', maxbod
      write(*,*) 'Maximum profile length            = ', maxobs
      write(*,*) 'Number of recoverable steps       = ', nsav
      write(*,*) 'Digitizer delay factor            = ', idelay
      return
      end
c
c **************************************************************
      SUBROUTINE AMPL
c
c purpose : To automatically adjust the density or magnetization 
c           contrasts of all bodies to improve the fit of the 
c           calculated profile to the measured data.
c
$include:'magrav.cmn'
c
      data iwrite/0/, maxit/1/
c
      ibr = 0
      escale = 1.e4
      if(itype.eq.1) escale = 100.
      imoves = 1
      imovee = nfield(itype)
      nf = nfield(itype)
      if(nf.eq.0) then
        call error (' No observed data ')
        return
      endif
      if(itype.eq.1) then
        write(*,*)'Old density contrasts for each body : '
      else
        write(*,*)'Old magnetization contrasts for each body :'
      endif
      do 50 j=1 , maxbod
        if(npts(j).ne.0)write(*,1000)j,rhomag(j,itype),colour(j)
1000    format(i5,3x,f10.3,' (',a10,')')
50    continue
      call calcan
      nc = 0
      do 100 i = 1, maxbod
        if (npts(i).eq.0)  go to 100
        if(abs(rhomag(i,itype)).ge.1.e-10) then
          do 110 j = 1, nf
            calc(i,j) = calc(i,j)/rhomag(i,itype)
110       continue
          nc = nc + 1
          xx(nc) = rhomag(i,itype)
          e(nc) = .001
        endif
100   continue
      if (nc.eq.0) then
        call error (' No bodies defined')
        kalk = 1
        return
      endif
      ierr = 0
      call dfs001(nf,nc,f,xx,e,escale,iwrite,maxit,w,ierr)
      if(ierr.ne.0) then
        call error ('Error in subroutine DFS001')
        write(*,1111) sgr1
        write(*,*)'(err=',ierr,')'
        write(*,1111) sgr0
        kalk = 1
        return
      endif
      nc = 0
      do 200 i = 1, maxbod
        if(npts(i).eq.0) go to 200
        if(abs(rhomag(i,itype)).ge.1.e-10) then
          nc = nc + 1
          rhomag(i,itype) = xx(nc)
        endif
200   continue
      do 300 i = 1, nf
        calc(maxcal,i) = 0.
300   continue
      do 400 i = 1, maxbod
        if(npts(i).eq.0) go to 400
        do 410 j = 1, nf
          calc(i,j) = calc(i,j)*rhomag(i,itype)
          calc(maxcal,j) = calc(maxcal,j) + calc(i,j)
410     continue
400   continue
      kalk = 0
      if(itype.eq.1) then
        write(*,*)'New density contrasts for each body :'
      else
        write(*,*)'New magnetization contrasts for each body :'
      endif
      do 500 j = 1 , maxbod
        if(npts(j).ne.0)write(*,1000)j,rhomag(j,itype),colour(j)
500   continue
      return
      end
c
c **************************************************************
      SUBROUTINE AMPBOD (IBOD)
c
c purpose : To automatically adjust the density or magnetization 
c           contrasts of body (IBOD) to improve the fit of the 
c           calculated profile to the measured data.
c
$include:'magrav.cmn'
c
      data iwrite/0/, maxit/1/
c
      nmove = imovee - imoves + 1
      ibr = 2
      escale = 1.e4
      if(itype.eq.1) escale = 100.
      nf = nfield(itype)
      if(nf.eq.0) then
        call error (' No observed data ')
        return
      endif
c
      write(*,1000) ibod, colour(ibod)
1000  format(/,' Body:',i5,' (',a10,')')
      if(itype.eq.1) then
        write(*,1010) rhomag(ibod,itype)
1010    format(/,' Old density contrast =',f10.4)
      else
        write(*,1020) rhomag(ibod,itype)
1020    format(/,' Old magnetization contrast =',f10.3)
      endif
c
      call calcan
c
      if (npts(ibod).eq.0) then
        call error('no points defined in body')
        return
      endif
c
      if(abs(rhomag(ibod,itype)).lt.1.e-10) then
         call error('Contrast not set for body, call EPAR')
         return
      endif
c 
c Divide anomaly for selected body by its density or magnetization
c
      do 110 j = 1, nf
        calc(ibod,j) = calc(ibod,j)/rhomag(ibod,itype)
110   continue
c
c Optimize density or magnetization for body
c  Flag optimized body for CALFUN by setting 
c  "rhomag(ibod,itype) = 99999999.999"
c
      kalk = 1
      ierr = 0
      nc = 1
      xx(nc) = rhomag(ibod,itype)
      rhomag(ibod,itype) = 99999999.999
      e(nc) = .001
      call dfs001(nmove,nc,f,xx,e,escale,iwrite,maxit,w,ierr)
      if(ierr.ne.0) then
        call error ('Error in subroutine DFS001')
        write(*,1111) sgr1
        write(*,*)'(err=',ierr,')'
        write(*,1111) sgr0
        kalk = 1
        return
      endif
c
      rhomag(ibod,itype) = xx(1)
c
      do 300 i = 1, nf
        calc(maxcal,i) = 0.
300   continue
c
c Sum individual body anomalies to get total anomaly multiplying
c   the selected body by the new contrast
c
      do 400 jbod = 1, maxbod
        if(npts(jbod).eq.0) go to 400
        do 410 j = 1, nf
          if(jbod.eq.ibod) then
            calc(jbod,j) = calc(jbod,j)*rhomag(jbod,itype)
          endif
            calc(maxcal,j) = calc(maxcal,j) + calc(jbod,j)
410     continue
400   continue
c
      kalk = 0
      if(itype.eq.1) then
        write(*,1030) rhomag(ibod,itype)
1030    format(/,' New density contrast =',f10.4)
      else
        write(*,1040) rhomag(ibod,itype)
1040    format(/,' New magnetization contrast =',f10.3)
      endif
      return
      end

c
*********************************************************************
      SUBROUTINE CALFUN (IAMP)
c
c purpose : This program is called by subroutine "DFS001" to
c          calculate the values in array "f" .Array "f" contains the 
c          difference between the calculated and observed profiles.
c
c parameters : iamp -"1" for initial calls of contrast optimization
c                    "0" for later calls
c
$include:'magrav.cmn'
c
      do 100 i = 1, maxobs
        calc(maxcal,i) = 0.
100   continue
c
c For contrast optimization, all bodies
c
      if (ibr.eq.0) then
        nc = 0
        do 200 i = 1, maxbod
          if(npts(i).eq.0) go to 200
          if(abs(rhomag(i,itype)).ge.1.e-10) then
            nc = nc + 1
            if(iamp.ne.1) then
              if(xx(nc).lt.rmmin(i,itype)) xx(nc) = rmmin(i,itype)
              if(xx(nc).gt.rmmax(i,itype)) xx(nc) = rmmax(i,itype)
            endif
            do 220 j = 1, nfield(itype)
              calc(maxcal,j) = calc(maxcal,j) + calc(i,j) * xx(nc)
220         continue
          endif
200     continue
      endif
c
c For contrast optimization, one body, body flagged by
c   "rhomag(ibod,itype) = 99999999.999"
c
      if (ibr.eq.2) then
c
        do 290 i=1, maxbod
         if(iamp.ne.1.and.rhomag(i,itype).eq.99999999.999) then
           if(xx(1).lt.rmmin(i,itype)) xx(1) = rmmin(i,itype)
           if(xx(1).gt.rmmax(i,itype)) xx(1) = rmmax(i,itype)
         endif
290    continue
c
        do 300 i = 1, maxbod
          if(npts(i).eq.0) go to 300
          if(abs(rhomag(i,itype)).ge.1.e-10) then
            do 320 j = 1, nfield(itype)
              if(rhomag(i,itype).eq.99999999.999) then
                calc(maxcal,j) = calc(maxcal,j) + calc(i,j) * xx(1)
              else
                calc(maxcal,j) = calc(maxcal,j) + calc(i,j)
              endif
320         continue
          endif
300     continue
      endif
c
c For position optimization: identify bodies affected by optimization
c
      if (ibr.eq.1) then
        do 400 i = 1, 2
          if(ib(i).ne.0) then
            x(np(i),ib(i)) = xx(1)
            z(np(i),ib(i)) = abs(xx(2))
            ianom(ib(i)) = 0
c          write(*,*)'CALFUN:i,xx(1),xx(2)=',i,xx(1),xx(2)
          endif
400     continue
c
        do 420 i = 3, 4
          if(ib(i).ne.0) then
            x(np(i),ib(i)) = xx(3)
            z(np(i),ib(i)) = abs(xx(4))
            ianom(ib(i)) = 0
          endif
420     continue
c
        do 500 ibod = 1, maxbod
        if(npts(ibod).eq.0) go to 500
          if(npts(ibod).gt.0) then
            if(ianom(ibod).ge.0) then
              if(itype.eq.2) call mag(ibod)
              if(itype.eq.1) call gravc(ibod)
              ianom(ibod) = -1
            endif
            nf = nfield(itype)
c
            do 520 i = 1, nf
              calc(maxcal,i) = calc(maxcal,i) + calc(ibod,i)
 520        continue
          endif
 500    continue
      endif
c
c Calculate differences between observed and calculated and
c  store in array "f" for DFS001 for the profile segment. 
c For undefined observed stations det diff = 0.0
c
      ii = 0
      do 600 i = imoves, imovee
        ii = ii + 1
        if(obs(itype,i).eq.-9999.0) then
          f(ii) = 0.0
        else
          f(ii) = obs(itype,i)-calc(maxcal,i) + offset(itype)
        endif
 600  continue
c      write(*,*)'CALFUN "f" values'
c      write(*,*) (f(j),j=1,ii)
      return
      end
c
c *******************************************************************
      SUBROUTINE AMOVE (X1,X2,X3,X4,NPC)
c
c purpose : To set up varaibles and arrays for subroutine "DFS001"
c         so that points can be moved automatically to achieve a best
c         fit of the calculated anomaly with the observed anomaly for
c         the profile section selected
c
c parameters : x1   - first independent variable,"x" for point #1
c              x2   - second    "         "     ,"z"  "    "   #1
c              x3   - third     "         "     ,"x"  "    "   #2
c              x4   - fourth    "         "     ,"z"  "    "   #2
c             npc   - number of independent variables, 2 for 1 point
c
$include:'magrav.cmn'
c
      data iwrite/0/, maxit/2/
c
c "ESCALE" is used to control the movement of points and is set equal to
c  the profile length.
c
      escale = xpos(nfield(itype),itype) - xpos(1,itype)
c
      do 100 i = 1, maxbod
        xx(i) = 0.
100   continue
c
      nmove = imovee - imoves + 1
c      write(*,*)'AMOVE:imovee,imoves,nmove=',imovee,imoves,nmove
c
c Check which bodies the selected point is found in
c
      xx(1) = x1
      xx(2) = x2
      xx(3) = x3
      xx(4) = x4
      ibr = 1
      if(nfield(itype).eq.0) then
        call error ( 'No observed data defined!')
        return
      endif
      n1 = 0
      n2 = 0
      do 200 i = 1, 4
        ib(i) = 0
        np(i) = 0
200   continue
      do 300 number = 1, 2
        call check(number,xx(1),xx(2),ibod,npt,iret)
        if(iret.eq.0) then
          ib(number) = ibod
          np(number) = npt
          n1 = 1
        endif
        if(npc.ne.2) then
          call check(number,xx(3),xx(4),ibod,npt,iret)
          if(iret.eq.0) then
            ib(number + 2) = ibod
            np(number + 2) = npt
            n2 = 1
          endif
        endif
300   continue
c
      ntot = n1 + n2
      if(ntot.eq.0) return
      n3 = ntot * 2
c
      do 400 i = 1, n3
        e(i) = .001
400   continue
c
      ierr = 0
      call dfs001(nmove,n3,f,xx,e,escale,iwrite,maxit,w,ierr)
c      if(ierr.ne.0) go to 450
      xposf = xpos(nfield(itype),itype)
      if(xx(1).gt.xposf) xx(1) = xposf
      if(xx(1).lt.0.)xx(1) = 0.
      if(xx(2).lt.0.)xx(2) = 0.
      if(xx(2).gt.zmax)xx(2) = zmax
      if(n3.ne.2) then
        if(xx(3).gt.xposf) xx(3) = xposf
        if(xx(3).lt.0.) xx(3) = 0.
        if(xx(4).lt.0.) xx(4) = 0.
        if(xx(4).gt.zmax) xx(4) = zmax
      endif
      k = -2
c
      do 500 i = 1, 2
        i1 = i + i - 1
        i2 = i1 + 1
        k = k + 2
        do 520 j = 1, 2
          l = k + j
          ibl = ib(l)
          npl = np(l)
          if(ibl.ne.0) then
            x(npl,ibl) = xx(i1)
            z(npl,ibl) = xx(i2)
            ianom(ibl) = 0
            if(npl.eq.1) then
              x(npts(ibl),ibl) = x(1,ibl)
              z(npts(ibl),ibl) = z(1,ibl)
            endif
            call remdup (ibl)
            call plbod(ibl,-1)
          endif
520     continue
500   continue
c
      kalk = 1
      call planom(0,nclr)
      return
      end
c
c *****************************************************
      SUBROUTINE LCVAR(L,STRING)
c
c Purpose : To return the position of the first blank
c            character in a string in "l".
c
c Arguments : l - position of 1st blank character
c         string- character string to be searched
c
      character string*80, charl
c
      do 10 j=1, 80
        l = j
        charl = string (l:l)
        if(charl.eq.' ') return
10    continue
c
      return
      end
